#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	ofBackground(0,0,0);
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	
	ofEnableAlphaBlending();
	
	width = 10;
	
	
	for (int i = 0; i < 100; i++){
		particle myParticle;
		
		float x = 500 + 100 * cos ( (i / 200.0) * TWO_PI);
		float y = 500 + 100 * sin ( (i / 200.0) * TWO_PI);
		
		myParticle.setInitialCondition(x,y ,0,0);
		particles.push_back(myParticle);
	}
	
	// change this to
	// for (int i = 0; i < 10; i++){
	// to see a chain
	
	/*for (int i = 0; i < particles.size(); i++){
		spring mySpring;
		mySpring.distance		= 4;
		mySpring.springiness	= 0.2f;
		mySpring.particleA = & (particles[i  ]);
		mySpring.particleB = & (particles[(i+1) % particles.size()]);
		springs.push_back(mySpring);
	}*/
	
	for (int i = 0; i < particles.size(); i++){
		spring mySpring;
		mySpring.distance		= 4;
		mySpring.springiness	= 0.2f;
		
		if ( (i+1)%width != 0 ){
			mySpring.particleA = & (particles[i]);
			mySpring.particleB = & (particles[i+1]);
			springs.push_back(mySpring);
		}
		
		
		spring mySpring2;
		mySpring2.distance		= 4;
		mySpring2.springiness	= 0.2f;
		
		if ( i < particles.size() - width ){
			mySpring2.particleA = & (particles[i]);
			mySpring2.particleB = & (particles[i+width]);
			springs.push_back(mySpring2);
			
		}
	}
	
		
	
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
	}
	
	for (int i = 0; i < particles.size(); i++){
		
		//particles[i].addRepulsionForce(mouseX, mouseY, 200, 0.7f);
		
		for (int j = 0; j < i; j++){
			particles[i].addRepulsionForce(particles[j], 300, 0.1);
		}
	}
	
	for (int i = 0; i < springs.size(); i++){
		springs[i].update();
	}
	
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].bounceOffWalls();
		particles[i].addDampingForce();
		particles[i].update();
	}
}

//--------------------------------------------------------------
void testApp::draw(){
	
	/*ofSetColor(0xffffff);
	for (int i = 0; i < particles.size(); i++){
		particles[i].draw();
	}
	
	for (int i = 0; i < springs.size(); i++){
		springs[i].draw();
	}*/
	
	ofFill();
	ofSetColor( 255, 255, 255, 100 );
	for ( int i = 0; i < (particles.size()/width)-1; i++ ){
		for ( int j = 0; j < width-1; j++ ){
			
			if ( j % 2 == 0 )
				ofSetColor( 100, 100, 0, 100 );
			else 
				ofSetColor( 100, 0, 100, 100 );
			
			ofBeginShape();
				ofVertex( particles[i*width+j].pos.x, particles[i*width+j].pos.y );
				ofVertex( particles[i*width+j + 1].pos.x, particles[i*width+j + 1].pos.y );
				ofVertex( particles[(i+1)*width+j+1].pos.x, particles[(i+1)*width+j+1].pos.y );
				ofVertex( particles[(i+1)*width+j].pos.x, particles[(i+1)*width+j].pos.y );
			ofEndShape( true );

			
			
			if ( i % 2 == 0 )
				ofSetColor( 100, 100, 0, 100 );
			else 
				ofSetColor( 100, 0, 100, 100 );
			
			ofBeginShape();
			ofVertex( particles[i*width+j].pos.x, particles[i*width+j].pos.y );
			ofVertex( particles[i*width+j + 1].pos.x, particles[i*width+j + 1].pos.y );
			ofVertex( particles[(i+1)*width+j+1].pos.x, particles[(i+1)*width+j+1].pos.y );
			ofVertex( particles[(i+1)*width+j].pos.x, particles[(i+1)*width+j].pos.y );
			ofEndShape( true );
			
			
			
		}
	}
	
	ofSetColor(255, 0, 0);
	ofCircle( particles[ 0 ].pos.x, particles[ 0 ].pos.y, 2 );
	
	ofSetColor( 0, 0, 255 );
	ofCircle( particles[ width-1 ].pos.x, particles[ width-1 ].pos.y, 2 );
	
	

}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	switch (key){
			
		case ' ':
			// reposition everything: 
			for (int i = 0; i < particles.size(); i++){
				particles[i].setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
			}
			break;
	}
	
	
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	particles[0].pos.set(mouseX, mouseY);
	/*particles.erase(particles.begin());
	particle myParticle;
	myParticle.setInitialCondition(x,y,0,0);
	particles.push_back(myParticle);*/
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	particles[0].bFixed = true;
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
	
	particles[0].bFixed = false;
}

